Crypto::Bcrypt::Password - Crystal 1.20.1

# class Crypto::Bcrypt::Password

- Crypto::Bcrypt::Password
- Reference
- Object

##
Overview

Generate, read and verify `Crypto::Bcrypt` hashes.

NOTE To use `Password`, you must explicitly import it with `require "crypto/bcrypt/password"`

    require "crypto/bcrypt/password"

    password = Crypto::Bcrypt::Password.create("super secret", cost: 10)
    # => $2a$10$rI4xRiuAN2fyiKwynO6PPuorfuoM4L2PVv6hlnVJEmNLjqcibAfHq

    password.verify("wrong secret") # => false
    password.verify("super secret") # => true

See `Crypto::Bcrypt` for hints to select the cost when generating hashes.

##
Defined in:

crypto/bcrypt/password.cr

##
Constructors

- .create(password : String, cost : Int32 = DEFAULT_COST) : self

  Hashes a password.

- .new(raw_hash : String)

  Loads a bcrypt hash.

##
Instance Method Summary

- #cost : Int32
- #digest : String
- #inspect(io : IO) : Nil

  Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.

- #salt : String
- #to_s(io : IO) : Nil

  Returns the bcrypt hash, suitable for storage and use in `Crypto::Bcrypt::Password.new`.

- #verify(password : String) : Bool

  Verifies a password against the hash.

- #version : String

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.create(password : String, cost : Int32 = DEFAULT_COST) : self #

Hashes a password.

    require "crypto/bcrypt/password"

    password = Crypto::Bcrypt::Password.create("super secret", cost: 10)
    # => $2a$10$rI4xRiuAN2fyiKwynO6PPuorfuoM4L2PVv6hlnVJEmNLjqcibAfHq

def self.new(raw_hash : String) #

Loads a bcrypt hash.

    require "crypto/bcrypt/password"

    password = Crypto::Bcrypt::Password.new("$2a$10$X6rw/jDiLBuzHV./JjBNXe8/Po4wTL0fhdDNdAdjcKN/Fup8tGCya")
    password.version # => "2a"
    password.salt    # => "X6rw/jDiLBuzHV./JjBNXe"
    password.digest  # => "8/Po4wTL0fhdDNdAdjcKN/Fup8tGCya"

##
Instance Method Detail

def cost : Int32 #
def digest : String #
def inspect(io : IO) : Nil #
Description copied from class Reference

Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.

    class Person
      def initialize(@name : String, @age : Int32)
      end
    end

    Person.new("John", 32).inspect # => #<Person:0x10fd31f20 @name="John", @age=32>

def salt : String #
def to_s(io : IO) : Nil #

Returns the bcrypt hash, suitable for storage and use in `Crypto::Bcrypt::Password.new`.

    require "crypto/bcrypt/password"

    password = Crypto::Bcrypt::Password.create("super secret")
    password.to_s # => "$2a$11$zs8yeubYXMGGJmWyIYdFtO9aOrx44g5rarvixyBfl1klr3dZPG8Ma"

def verify(password : String) : Bool #

Verifies a password against the hash.

    require "crypto/bcrypt/password"

    password = Crypto::Bcrypt::Password.create("super secret")
    password.verify("wrong secret") # => false
    password.verify("super secret") # => true

def version : String #